local HEARTBEAT_INTERVAL = 0.5; -- how many seconds per heartbeat of our internal timer
Simple_Coords_SecondsSinceUpdate=0;

local mapIcon;
local panelOpen = false;
local haveArrived=false;
local HALF_PI = math.pi / 2;
-- Bring in AstroLabe
local DongleFrames = DongleStub("DongleFrames-1.0")
local Astrolabe = DongleStub("Astrolabe-0.4")

function Simple_Coords_OnUpdate(elapsed)
	Simple_Coords_SecondsSinceUpdate = Simple_Coords_SecondsSinceUpdate + elapsed; 	
	if (Simple_Coords_SecondsSinceUpdate > HEARTBEAT_INTERVAL) then
		local x, y = GetPlayerMapPosition("player");
		
		if x == 0 then
			Simple_CoordsText:SetText("---");
		else
			Simple_CoordsText:SetText(format( "%.1f, %.1f", x * 100, y * 100));
			Astrolabe:UpdateMinimapIconPositions();
		end
		Simple_Coords_SecondsSinceUpdate=0;
	end -- if
end

function SimpleCoords_OnLoad()
	-- create the dot: (encapsulated as an obbject in case we want to reuse it
	-- mapIcon=CreateFrame("Button", nil, Minimap)
	mapIcon=CreateFrame("Button", "SimpleCoordsDotFrame", Minimap)
	mapIcon:SetHeight(12)
	mapIcon:SetWidth(12)
	-- icon:RegisterForClicks("RightButtonUp")
	local texture = mapIcon:CreateTexture()
	texture:SetTexture("Interface\\Minimap\\ObjectIcons")
	texture:SetTexCoord(0.5, 0.75, 0, 0.25)
	texture:SetAllPoints()
	mapIcon.dot = texture
	--mapIcon.dot:Hide() -- start  hidden
	mapIcon.dot:Show();
	mapIcon:SetScript("OnUpdate", SimpleCoords_MapIcon_Update)

	-- create the arrow:
	local model = CreateFrame("Model", nil, icon)
	model:SetHeight(140.8)
	model:SetWidth(140.8)
	model:SetPoint("CENTER", Minimap, "CENTER", 0, 0)
	model:SetModel("Interface\\Minimap\\Rotating-MinimapArrow.mdx")
	model:SetModelScale(.600000023841879)

	model.parent = mapIcon
	mapIcon.arrow = model
	model:SetScript("OnUpdate", SimpleCoords_MapIcon_UpdateArrow)
	model:Hide()
	-- mapIcon.arrow:Show();
	-- add a "showing" flag:
	mapIcon.inUse=false;
	
	-- Register the slash command
	SLASH_SIMPLECOORDS1 = "/dest";
	SlashCmdList["SIMPLECOORDS"] = SimpleCoords_CommandLine;
	-- make a global for testing:
	SimpleCoordsMapIcon=mapIcon;
	
	DEFAULT_CHAT_FRAME:AddMessage("SimpleCoords loaded. Shift-drag to move the window. Click window to toggle panel. ENTER to set new value.",  0.5, 1.0, 0.5, 1);

end



function SimpleCoords_AcceptValue()
	-- DEFAULT_CHAT_FRAME:AddMessage("ENTER has been pressed",  0.5, 1.0, 0.5, 1);
	-- check to see if we need to remove an existing one:
	if (mapIcon.inUse) then
		Astrolabe:RemoveIconFromMinimap( mapIcon );
		mapIcon.inUse=false;
	end
	local dest_x=tonumber(getglobal("SimpleCoords_X"):GetText())/100.0;
	local dest_y=tonumber(getglobal("SimpleCoords_Y"):GetText())/100.0;
	
	local ppContinent, ppZone, ppX, ppY=Astrolabe:GetCurrentPlayerPosition();
	local r=Astrolabe:PlaceIconOnMinimap( mapIcon, ppContinent, ppZone, dest_x, dest_y );
		-- DEFAULT_CHAT_FRAME:AddMessage('result='..r..', '..ppContinent..', '..ppZone..', '..dest_x..', '..dest_y,  0.5, 1.0, 0.5, 1);

	mapIcon.inUse=true;
	Astrolabe:UpdateMinimapIconPositions();
	haveArrived=false;
end

function SimpleCoords_TogglePanel()
	if(getglobal("SimpleCoords_X"):IsShown()) then
	
		getglobal("SimpleCoords_X"):Hide();
		getglobal("SimpleCoords_Y"):Hide();
		getglobal("SimpleCoords_X"):ClearFocus();
		getglobal("SimpleCoords_Y"):ClearFocus();
		Astrolabe:RemoveIconFromMinimap(mapIcon);
		Astrolabe:UpdateMinimapIconPositions();
		mapIcon.inUse=false;
		panelOpen=false;
		
	else
		getglobal("SimpleCoords_X"):Show();
		getglobal("SimpleCoords_Y"):Show();
		getglobal("SimpleCoords_X"):SetFocus();
		panelOpen=true;
	end


end

function SimpleCoords_MapIcon_UpdateArrow(self, elapsed)
	local angle = Astrolabe:GetDirectionToIcon(mapIcon)
	if (angle ~= nil) then
		local x = .03875* math.cos(angle + HALF_PI) + 0.04875 
		local y = .03875* math.sin(angle + HALF_PI) + 0.04875 
		self:SetPosition(x,y,0)
		self:SetFacing(angle)
	else
		self:Hide()
	end
end

function SimpleCoords_MapIcon_Update(self, elapsed)
	local edge = Astrolabe:IsIconOnEdge(self)
	local dot = self.dot:IsShown()
	local arrow = self.arrow:IsShown()

	if (edge and not arrow) then

		self.arrow:Show()
		self.dot:Hide()
	elseif not edge and not dot then
		self.dot:Show()
		self.arrow:Hide()
	end

	local dist,x,y = Astrolabe:GetDistanceToIcon(self)
	if (dist and dist < 10) then
		if (not haveArrived) then	
			-- let them now they have arrived
			DEFAULT_CHAT_FRAME:AddMessage("You have arrived.",  0.8, 1.0, 0.5, 1);
			haveArrived=true;
		end
	else
		haveArrived=false;
	end
	
end




-- command line parameters: (slash command handler)
function SimpleCoords_CommandLine(msg)
	cmd=string.lower(msg)
	
	
end